#pragma once
#ifdef __USE_PROFILE_IMG_BY_P2P__
#include "CommonType_Private.h"
#include "ActorInterface.h"
#include "ProfileImageActor.h"
/////////////////////////////////////////////
#include "incconferenceintf.h"
#include "INpMsgrP2P.h"
/////////////////////////////////////////////


class CProfileImageRecverP2P : public _INpStreamSessionEvents, public IGTWASActorEventPrivate
{
public:
	CProfileImageRecverP2P(CProfileImageActor *pActor);
	~CProfileImageRecverP2P(void);

	bool RequestGetImage(LPCWSTR strUserID, GTProfileImageSizeType eSizeType = profileOriginalSize, DWORD dwUserData1 = NULL, DWORD dwUserData2 = NULL);

	DWORD GetUserData1()
	{
		return m_dwUserData1;
	}

	DWORD GetUserData2()
	{
		return m_dwUserData2;
	}

	const LPCWSTR GetUserID()
	{
		return m_sData.strUserID.c_str();
	}

	void GetData(P_GT_PROFILE_IMAGE_DATA &sData)
	{
		sData = m_sData;
	}

private:
	bool RequestGetImageFromWAS(void);
	bool CheckImage(void);
	bool CopyFromTempFile(void);

protected:
	// _INpStreamSessionEvents 
	virtual void CALLBACK NpStreamSession_OnConnect(INpStreamSession *pSession, int nResultCode, int nErrorCode);
	virtual void CALLBACK NpStreamSession_OnClose(INpStreamSession *pSession, int nSocketError, bool bRecvInvalidPacket);
	virtual void CALLBACK NpStreamSession_OnRecvPacket(INpStreamSession *pSession, INpPacket * pPacket);
	virtual void CALLBACK NpStreamSession_OnSendReady(INpStreamSession * /*pSession*/);

	// IGTWASActorEvent 
	virtual bool OnGTWASActor_ResponseProfileImage(IGTWASActor *pActor, 
		trid_t trid,
		GTWASCallErrorCode eErrorCode, 
		GTProfileImgError eProfileError, 
		bool bUploadFile, 
		const GT_PROFILE_IMAGE_DATA& sData,
		DWORD dwUserData1,
		DWORD dwUserData2);

private:
	// User Data..
	DWORD m_dwUserData1;
	DWORD m_dwUserData2;

	bool m_bWorking;
	bool m_bReady;

	trid_t m_tridDownloadFromWAS;
	WSTRING m_strTempFile;
	HANDLE m_hTempFile;

	P_GT_PROFILE_IMAGE_DATA m_sData;

	INpStreamSession * m_pSession;
	CProfileImageActor *m_pProfileImageActor;
};

#endif